#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK64x64x64TN64x64x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=64, NB=64, KB=64, 
 * lda=64, ldb=64, ldc=0, mu=1, nu=8, ku=24, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *stM = A + 4096;
   const double *stN = B + 4096;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*8)/(64*64);
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 24
   const int incAm = 16, incAn = -4096;
   #define incBk 24
   const int incBm = -48, incBn = 512;
   #define incCm 2
   const int incCn = (((ldc) << 4)) - 128;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1)), *pC6=pC5+(((ldc) << 1)), *pC7=pC6+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC0_4 = *pC4;
         rC0_4 *= rA0;
         rC0_5 = *pC5;
         rC0_5 *= rA0;
         rC0_6 = *pC6;
         rC0_6 *= rA0;
         rC0_7 = *pC7;
         rC0_7 *= rA0;
         for (k=48; k; k -= 24) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[64];
            rB2 = pB0[128];
            rB3 = pB0[192];
            rB4 = pB0[256];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[320];
            rB6 = pB0[384];
            rB7 = pB0[448];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[65];
            rB2 = pB0[129];
            rB3 = pB0[193];
            rB4 = pB0[257];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[321];
            rB6 = pB0[385];
            rB7 = pB0[449];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB0[66];
            rB2 = pB0[130];
            rB3 = pB0[194];
            rB4 = pB0[258];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[322];
            rB6 = pB0[386];
            rB7 = pB0[450];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rB1 = pB0[67];
            rB2 = pB0[131];
            rB3 = pB0[195];
            rB4 = pB0[259];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[323];
            rB6 = pB0[387];
            rB7 = pB0[451];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rB1 = pB0[68];
            rB2 = pB0[132];
            rB3 = pB0[196];
            rB4 = pB0[260];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[324];
            rB6 = pB0[388];
            rB7 = pB0[452];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rB1 = pB0[69];
            rB2 = pB0[133];
            rB3 = pB0[197];
            rB4 = pB0[261];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[325];
            rB6 = pB0[389];
            rB7 = pB0[453];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rB1 = pB0[70];
            rB2 = pB0[134];
            rB3 = pB0[198];
            rB4 = pB0[262];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[326];
            rB6 = pB0[390];
            rB7 = pB0[454];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rB1 = pB0[71];
            rB2 = pB0[135];
            rB3 = pB0[199];
            rB4 = pB0[263];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[327];
            rB6 = pB0[391];
            rB7 = pB0[455];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rB1 = pB0[72];
            rB2 = pB0[136];
            rB3 = pB0[200];
            rB4 = pB0[264];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[328];
            rB6 = pB0[392];
            rB7 = pB0[456];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rB1 = pB0[73];
            rB2 = pB0[137];
            rB3 = pB0[201];
            rB4 = pB0[265];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[329];
            rB6 = pB0[393];
            rB7 = pB0[457];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rB1 = pB0[74];
            rB2 = pB0[138];
            rB3 = pB0[202];
            rB4 = pB0[266];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[330];
            rB6 = pB0[394];
            rB7 = pB0[458];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rB1 = pB0[75];
            rB2 = pB0[139];
            rB3 = pB0[203];
            rB4 = pB0[267];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[331];
            rB6 = pB0[395];
            rB7 = pB0[459];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rB1 = pB0[76];
            rB2 = pB0[140];
            rB3 = pB0[204];
            rB4 = pB0[268];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[332];
            rB6 = pB0[396];
            rB7 = pB0[460];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rB1 = pB0[77];
            rB2 = pB0[141];
            rB3 = pB0[205];
            rB4 = pB0[269];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[333];
            rB6 = pB0[397];
            rB7 = pB0[461];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rB1 = pB0[78];
            rB2 = pB0[142];
            rB3 = pB0[206];
            rB4 = pB0[270];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[334];
            rB6 = pB0[398];
            rB7 = pB0[462];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rB1 = pB0[79];
            rB2 = pB0[143];
            rB3 = pB0[207];
            rB4 = pB0[271];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[335];
            rB6 = pB0[399];
            rB7 = pB0[463];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rB1 = pB0[80];
            rB2 = pB0[144];
            rB3 = pB0[208];
            rB4 = pB0[272];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[336];
            rB6 = pB0[400];
            rB7 = pB0[464];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rB1 = pB0[81];
            rB2 = pB0[145];
            rB3 = pB0[209];
            rB4 = pB0[273];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[337];
            rB6 = pB0[401];
            rB7 = pB0[465];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rB1 = pB0[82];
            rB2 = pB0[146];
            rB3 = pB0[210];
            rB4 = pB0[274];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[338];
            rB6 = pB0[402];
            rB7 = pB0[466];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rB1 = pB0[83];
            rB2 = pB0[147];
            rB3 = pB0[211];
            rB4 = pB0[275];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[339];
            rB6 = pB0[403];
            rB7 = pB0[467];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rB1 = pB0[84];
            rB2 = pB0[148];
            rB3 = pB0[212];
            rB4 = pB0[276];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[340];
            rB6 = pB0[404];
            rB7 = pB0[468];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rB1 = pB0[85];
            rB2 = pB0[149];
            rB3 = pB0[213];
            rB4 = pB0[277];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[341];
            rB6 = pB0[405];
            rB7 = pB0[469];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rB1 = pB0[86];
            rB2 = pB0[150];
            rB3 = pB0[214];
            rB4 = pB0[278];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[342];
            rB6 = pB0[406];
            rB7 = pB0[470];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rB1 = pB0[87];
            rB2 = pB0[151];
            rB3 = pB0[215];
            rB4 = pB0[279];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[343];
            rB6 = pB0[407];
            rB7 = pB0[471];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[64];
         rB2 = pB0[128];
         rB3 = pB0[192];
         rB4 = pB0[256];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[320];
         rB6 = pB0[384];
         rB7 = pB0[448];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[65];
         rB2 = pB0[129];
         rB3 = pB0[193];
         rB4 = pB0[257];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[321];
         rB6 = pB0[385];
         rB7 = pB0[449];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[66];
         rB2 = pB0[130];
         rB3 = pB0[194];
         rB4 = pB0[258];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[322];
         rB6 = pB0[386];
         rB7 = pB0[450];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB0[67];
         rB2 = pB0[131];
         rB3 = pB0[195];
         rB4 = pB0[259];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[323];
         rB6 = pB0[387];
         rB7 = pB0[451];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB0[68];
         rB2 = pB0[132];
         rB3 = pB0[196];
         rB4 = pB0[260];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[324];
         rB6 = pB0[388];
         rB7 = pB0[452];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rB1 = pB0[69];
         rB2 = pB0[133];
         rB3 = pB0[197];
         rB4 = pB0[261];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[325];
         rB6 = pB0[389];
         rB7 = pB0[453];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB0[70];
         rB2 = pB0[134];
         rB3 = pB0[198];
         rB4 = pB0[262];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[326];
         rB6 = pB0[390];
         rB7 = pB0[454];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rB1 = pB0[71];
         rB2 = pB0[135];
         rB3 = pB0[199];
         rB4 = pB0[263];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[327];
         rB6 = pB0[391];
         rB7 = pB0[455];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rB1 = pB0[72];
         rB2 = pB0[136];
         rB3 = pB0[200];
         rB4 = pB0[264];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[328];
         rB6 = pB0[392];
         rB7 = pB0[456];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rB1 = pB0[73];
         rB2 = pB0[137];
         rB3 = pB0[201];
         rB4 = pB0[265];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[329];
         rB6 = pB0[393];
         rB7 = pB0[457];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rB1 = pB0[74];
         rB2 = pB0[138];
         rB3 = pB0[202];
         rB4 = pB0[266];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[330];
         rB6 = pB0[394];
         rB7 = pB0[458];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rB1 = pB0[75];
         rB2 = pB0[139];
         rB3 = pB0[203];
         rB4 = pB0[267];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[331];
         rB6 = pB0[395];
         rB7 = pB0[459];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rB1 = pB0[76];
         rB2 = pB0[140];
         rB3 = pB0[204];
         rB4 = pB0[268];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[332];
         rB6 = pB0[396];
         rB7 = pB0[460];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rB1 = pB0[77];
         rB2 = pB0[141];
         rB3 = pB0[205];
         rB4 = pB0[269];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[333];
         rB6 = pB0[397];
         rB7 = pB0[461];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rB1 = pB0[78];
         rB2 = pB0[142];
         rB3 = pB0[206];
         rB4 = pB0[270];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[334];
         rB6 = pB0[398];
         rB7 = pB0[462];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rB1 = pB0[79];
         rB2 = pB0[143];
         rB3 = pB0[207];
         rB4 = pB0[271];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[335];
         rB6 = pB0[399];
         rB7 = pB0[463];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         *pC6 = rC0_6;
         *pC7 = rC0_7;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
