#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK32x32x32TN0x0x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=32, NB=32, KB=32, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=8, ku=32, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *stM = A + (((lda) << 6));
   const double *stN = B + (((ldb) << 6));
   const double *pfA = A + M;
   #define incAk 64
   const int incAm = ((((lda) - 32) << 1)), incAn = -(((lda) << 6));
   #define incBk 64
   const int incBm = -64, incBn = (((ldb) << 4));
   #define incCm 2
   const int incCn = (((ldc) << 4)) - 64;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1)), *pC6=pC5+(((ldc) << 1)), *pC7=pC6+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1)), *pB4=pB3+(((ldb) << 1)), *pB5=pB4+(((ldb) << 1)), *pB6=pB5+(((ldb) << 1)), *pB7=pB6+(((ldb) << 1));
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
         rC0_4 = *pC4;
         rC0_5 = *pC5;
         rC0_6 = *pC6;
         rC0_7 = *pC7;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
         ATL_pfl1W(pC5);
         ATL_pfl1W(pC6);
         ATL_pfl1W(pC7);
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = *pB1;
         rB2 = *pB2;
         rB3 = *pB3;
         rB4 = *pB4;
         rC0_0 = rA0 * rB0;
         rB5 = *pB5;
         rB6 = *pB6;
         rB7 = *pB7;
         rC0_1 = rA0 * rB1;
         rC0_2 = rA0 * rB2;
         rC0_3 = rA0 * rB3;
         rC0_4 = rA0 * rB4;
         rC0_5 = rA0 * rB5;
         rC0_6 = rA0 * rB6;
         rC0_7 = rA0 * rB7;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rB3 = pB3[2];
         rB4 = pB4[2];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[2];
         rB6 = pB6[2];
         rB7 = pB7[2];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rB3 = pB3[4];
         rB4 = pB4[4];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[4];
         rB6 = pB6[4];
         rB7 = pB7[4];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB1[6];
         rB2 = pB2[6];
         rB3 = pB3[6];
         rB4 = pB4[6];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[6];
         rB6 = pB6[6];
         rB7 = pB7[6];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rB1 = pB1[8];
         rB2 = pB2[8];
         rB3 = pB3[8];
         rB4 = pB4[8];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[8];
         rB6 = pB6[8];
         rB7 = pB7[8];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rB1 = pB1[10];
         rB2 = pB2[10];
         rB3 = pB3[10];
         rB4 = pB4[10];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[10];
         rB6 = pB6[10];
         rB7 = pB7[10];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rB1 = pB1[12];
         rB2 = pB2[12];
         rB3 = pB3[12];
         rB4 = pB4[12];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[12];
         rB6 = pB6[12];
         rB7 = pB7[12];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rB1 = pB1[14];
         rB2 = pB2[14];
         rB3 = pB3[14];
         rB4 = pB4[14];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[14];
         rB6 = pB6[14];
         rB7 = pB7[14];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rB1 = pB1[16];
         rB2 = pB2[16];
         rB3 = pB3[16];
         rB4 = pB4[16];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[16];
         rB6 = pB6[16];
         rB7 = pB7[16];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rB1 = pB1[18];
         rB2 = pB2[18];
         rB3 = pB3[18];
         rB4 = pB4[18];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[18];
         rB6 = pB6[18];
         rB7 = pB7[18];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rB1 = pB1[20];
         rB2 = pB2[20];
         rB3 = pB3[20];
         rB4 = pB4[20];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[20];
         rB6 = pB6[20];
         rB7 = pB7[20];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rB1 = pB1[22];
         rB2 = pB2[22];
         rB3 = pB3[22];
         rB4 = pB4[22];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[22];
         rB6 = pB6[22];
         rB7 = pB7[22];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rB1 = pB1[24];
         rB2 = pB2[24];
         rB3 = pB3[24];
         rB4 = pB4[24];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[24];
         rB6 = pB6[24];
         rB7 = pB7[24];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rB1 = pB1[26];
         rB2 = pB2[26];
         rB3 = pB3[26];
         rB4 = pB4[26];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[26];
         rB6 = pB6[26];
         rB7 = pB7[26];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rB1 = pB1[28];
         rB2 = pB2[28];
         rB3 = pB3[28];
         rB4 = pB4[28];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[28];
         rB6 = pB6[28];
         rB7 = pB7[28];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rB1 = pB1[30];
         rB2 = pB2[30];
         rB3 = pB3[30];
         rB4 = pB4[30];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[30];
         rB6 = pB6[30];
         rB7 = pB7[30];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rB1 = pB1[32];
         rB2 = pB2[32];
         rB3 = pB3[32];
         rB4 = pB4[32];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[32];
         rB6 = pB6[32];
         rB7 = pB7[32];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rB1 = pB1[34];
         rB2 = pB2[34];
         rB3 = pB3[34];
         rB4 = pB4[34];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[34];
         rB6 = pB6[34];
         rB7 = pB7[34];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rB1 = pB1[36];
         rB2 = pB2[36];
         rB3 = pB3[36];
         rB4 = pB4[36];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[36];
         rB6 = pB6[36];
         rB7 = pB7[36];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rB1 = pB1[38];
         rB2 = pB2[38];
         rB3 = pB3[38];
         rB4 = pB4[38];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[38];
         rB6 = pB6[38];
         rB7 = pB7[38];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rB1 = pB1[40];
         rB2 = pB2[40];
         rB3 = pB3[40];
         rB4 = pB4[40];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[40];
         rB6 = pB6[40];
         rB7 = pB7[40];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rB1 = pB1[42];
         rB2 = pB2[42];
         rB3 = pB3[42];
         rB4 = pB4[42];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[42];
         rB6 = pB6[42];
         rB7 = pB7[42];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rB1 = pB1[44];
         rB2 = pB2[44];
         rB3 = pB3[44];
         rB4 = pB4[44];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[44];
         rB6 = pB6[44];
         rB7 = pB7[44];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rB1 = pB1[46];
         rB2 = pB2[46];
         rB3 = pB3[46];
         rB4 = pB4[46];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[46];
         rB6 = pB6[46];
         rB7 = pB7[46];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[48];
         rB0 = pB0[48];
         rB1 = pB1[48];
         rB2 = pB2[48];
         rB3 = pB3[48];
         rB4 = pB4[48];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[48];
         rB6 = pB6[48];
         rB7 = pB7[48];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[50];
         rB0 = pB0[50];
         rB1 = pB1[50];
         rB2 = pB2[50];
         rB3 = pB3[50];
         rB4 = pB4[50];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[50];
         rB6 = pB6[50];
         rB7 = pB7[50];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[52];
         rB0 = pB0[52];
         rB1 = pB1[52];
         rB2 = pB2[52];
         rB3 = pB3[52];
         rB4 = pB4[52];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[52];
         rB6 = pB6[52];
         rB7 = pB7[52];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[54];
         rB0 = pB0[54];
         rB1 = pB1[54];
         rB2 = pB2[54];
         rB3 = pB3[54];
         rB4 = pB4[54];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[54];
         rB6 = pB6[54];
         rB7 = pB7[54];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[56];
         rB0 = pB0[56];
         rB1 = pB1[56];
         rB2 = pB2[56];
         rB3 = pB3[56];
         rB4 = pB4[56];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[56];
         rB6 = pB6[56];
         rB7 = pB7[56];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[58];
         rB0 = pB0[58];
         rB1 = pB1[58];
         rB2 = pB2[58];
         rB3 = pB3[58];
         rB4 = pB4[58];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[58];
         rB6 = pB6[58];
         rB7 = pB7[58];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[60];
         rB0 = pB0[60];
         rB1 = pB1[60];
         rB2 = pB2[60];
         rB3 = pB3[60];
         rB4 = pB4[60];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[60];
         rB6 = pB6[60];
         rB7 = pB7[60];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         rA0 = pA0[62];
         rB0 = pB0[62];
         rB1 = pB1[62];
         rB2 = pB2[62];
         rB3 = pB3[62];
         rB4 = pB4[62];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[62];
         rB6 = pB6[62];
         rB7 = pB7[62];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         rC0_7 += rA0 * rB7;
         pA0 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         pB4 += incBk;
         pB5 += incBk;
         pB6 += incBk;
         pB7 += incBk;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         *pC6 = rC0_6;
         *pC7 = rC0_7;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
         pB5 += incBm;
         pB6 += incBm;
         pB7 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
      pB6 += incBn;
      pB7 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
